--- a/net/mac80211/mesh.c
+++ b/net/mac80211/mesh.c
@@ -150,6 +150,10 @@ void mesh_sta_cleanup(struct sta_info *s
 	struct ieee80211_sub_if_data *sdata = sta->sdata;
 	u32 changed = mesh_plink_deactivate(sta);
 
+	/* make sure no readers can access nexthop sta from here on */
+	mesh_path_flush_by_nexthop(sta);
+	synchronize_net();
+
 	if (changed)
 		ieee80211_mbss_info_change_notify(sdata, changed);
 }
